#!/usr/bin/perl

use Socket;

$SERVER = "";
#$SERVER="wm.ictp.trieste.it";
$SENDMAIL="/usr/lib/sendmail";
$WWW4MAIL="www4mail\@wm.ictp.trieste.it";
$SENDER="nobody\@localhost";
$SUBJECT="Form submission by www4mail.cgi";

#Assume A POST OPERATION
$msg = "";
if (defined $ENV{'CONTENT_LENGTH'} and $ENV{'CONTENT_LENGTH'} > 0) {
  read(STDIN,$msg,$ENV{'CONTENT_LENGTH'});
}

#Check that we have WANID entry
$wanid = "";
my $no_show = 0;
my $do_split = 1;
if ($msg =~ /\&xw4wanid\=\s*([^&\r\n]+)\s*/is) {
	#Extract the WANID field content
	$wanid = "$1";
} elsif ($msg =~ /name=\"*xw4wanid\"*\s+([^\s]+)\s+\-\-/is) {
	$wanid = "$1";
	$do_split = 0;
}
print "Content-type: text/html\n\n"; 
print "<BODY BGCOLOR=\"#FFFFFF\">\n";
if ($wanid !~ /^\s*$/) {
	$res = &sendmail("$SENDER", "$WWW4MAIL", "$SERVER", "$SUBJECT", "$msg");
	if ($res > 0) {
		print "<H1>Thank you!</H1>\n";
		print "Your request has been sent to $WWW4MAIL.<BR>\n";
		print "The reply will be sent directly to you by e-mail.<BR>\n";
		print "<P>Here is a copy of the information sent: <P>\n";
	} else {
		print "<H1>INTERNAL ERROR at stage $res</H1>\n";
		print "Your request COULD NOT BE SENT. <BR>\n";
		$msg = "";
	}
} else {
	print "<H1>Sorry!</H1>\n";
	print "Your request could not be processed due to a<BR>\n";
	print "missing WWW4MAIL REQUIRED WAN ID VARIABLE.<BR>\n";
}
$msg = "" if ($no_show > 0);
if ($msg ne "") {
	print "<pre>\n";
	if ($do_split > 0) {
		foreach $one (split(/\&/, $msg)) {
			print "$one\n";
		}
	} else {
		print "$msg\n";
	}
	print "</pre>\n";
}
print "\n</BODY>";

exit 0;
sub sendmail  {

# &sendmail($from, $to, $smtp, $subject, $message );
# 
#

    my ($fromaddr, $to, $smtp, $subject, $message) = @_;

    my $res = -9;
    $to =~ s/[ \t]+/, /g; # pack spaces and add comma
    $fromaddr =~ s/.*<([^\s]*?)>/$1/; # get from email address
    $message =~ s/^\./\.\./gm; # handle . as first character
    $message =~ s/\r\n/\n/g; # handle line ending
    $message =~ s/\n/\r\n/g;
    $smtp =~ s/^\s+//g; # remove spaces around $smtp
    $smtp =~ s/\s+$//g;

    goto myerror if (!$to);

#meol Mail End of Line SMTP == \r\n PIPE = \n
  my $meol = "\n";
#Perl Socket code errors should result in a
#jump to sendmail program mailer
 if ($SERVER ne "")
  {
  $meol = "\r\n";
    my($proto) = (getprotobyname('tcp'))[2];
    my($port) = (getservbyname('smtp', 'tcp'))[2];

    my($smtpaddr) = ($smtp =~
		     /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/)
	? pack('C4',$1,$2,$3,$4)
	    : (gethostbyname($smtp))[4];
	$res = $res - 1;
    goto myprog if (!defined($smtpaddr));
	$res = $res - 1;

    goto myprog if (!socket(MAIL, AF_INET, SOCK_STREAM, $proto));
	$res = $res - 1;

    goto myprog if (!connect(MAIL, pack('Sna4x8', AF_INET, $port, $smtpaddr)));

    my($oldfh) = select(MAIL);
    $| = 1;
    select($oldfh);

    goto myprog if (!defined fileno(MAIL));
#SMTP Protocol LEVEL errors should result in an ABORT 
    $_ = <MAIL>;
	$res = $res - 1;
    goto myerror if (/^[45]/);

    print MAIL "HELO $SERVER\r\n";
    $_ = <MAIL>;
	$res = $res - 1;
    goto myerror if (/^[45]/);

    print MAIL "MAIL FROM: <$fromaddr>\r\n";
    $_ = <MAIL>;
	$res = $res - 1;
    goto myerror if (/^[45]/);

    foreach (split(/\s*,\s*/, $to))
    {
	print MAIL "RCPT TO: <$_>\r\n";
	$_ = <MAIL>;
	goto myerror if (/^[45]/);
    }

    print MAIL "DATA\r\n";
    $_ = <MAIL>;
	$res = $res - 1;
    goto myerror if (/^[45]/);

   }
#Socket connection failures will result in a jump here
myprog:
  if (!defined fileno(MAIL) and $SENDMAIL ne "")
   {
	#sendmail program mailer
     open (MAIL,"| $SENDMAIL $to");
	$meol = "\n";
   }

   goto myerror if (!defined fileno(MAIL));
    print MAIL "To: $to$meol";
    print MAIL "From: $fromaddr$meol";
    print MAIL "X-Mailer: $ENV{'HTTP_USER_AGENT'} www4mail.cgi/perl 0.6$meol";
    print MAIL "X-remote-ip: $ENV{'REMOTE_ADDR'}$meol";
    print MAIL "X-W4WANID: $wanid$meol";
    print MAIL "MIME-Version: 1.0$meol";
#For multipart/form-data we should set a boundary header ??
#How to get the user's Charset definition in a CGI??
    print MAIL "Content-Type: $ENV{'CONTENT_TYPE'}$meol" if (defined $ENV{'CONTENT_TYPE'} and $ENV{'CONTENT_TYPE'} !~ /^\s*$/);
    print MAIL "Content-Transfer-Encoding: 8bit$meol";
    print MAIL "Subject: $subject$meol$meol";
    print MAIL "$message";
#Send a final Blank line
    print MAIL "$meol";

 if ($SERVER ne "")
  {
    print MAIL ".$meol";
    $_ = <MAIL>;
	$res = $res - 1;
    goto myerror if (/^[45]/);

    print MAIL "quit$meol";
    $_ = <MAIL>;
  }
#set up return code
	$res = 1;
myerror:
    close(MAIL);
    return $res;
}

